%global         srcname         gourmand
%global         forgeurl        https://github.com/GourmandRecipeManager/gourmand
%global         srcversion      1.1.0rc3
Version:        1.1.0~rc3

Name:           gourmand
Release:        1%{?dist}
Summary:        Desktop cooking recipe manager

License:        GPL-2.0-only
URL:            %{forgeurl}
Source:         %{forgeurl}/archive/%{srcversion}/%{srcname}-%{srcversion}.tar.gz
Patch:          gdk_cursor.patch
Patch:          toml.patch

BuildRequires:  cairo-devel
BuildRequires:  cairo-gobject-devel
BuildRequires:  desktop-file-utils
BuildRequires:  enchant
BuildRequires:  intltool
BuildRequires:  gobject-introspection-devel
BuildRequires:  gtk3-devel
BuildRequires:  hspell-devel
BuildRequires:  libappstream-glib
BuildRequires:  libvoikko-devel
BuildRequires:  nuspell-devel
BuildRequires:  poppler-devel
BuildRequires:  poppler-glib-devel
#BuildRequires:  python-setuptools-wheel
BuildRequires:  python3-beautifulsoup4
BuildRequires:  python3-cairo-devel
BuildRequires:  python3-dogtail
BuildRequires:  python3-devel
# BuildRequires:  python3-ebooklib
BuildRequires:  python3-enchant
BuildRequires:  python3-gobject-devel
BuildRequires:  python3-gstreamer1
# BuildRequires:  python3-gtkspellcheck
BuildRequires:  python3-keyring
BuildRequires:  python3-libvoikko
BuildRequires:  python3-lxml
BuildRequires:  python3-pip
BuildRequires:  python3-pillow
BuildRequires:  python3-requests
BuildRequires:  python3-reportlab
# BuildRequires:  python3-scrape-schema-recipe
BuildRequires:  python3-selenium
BuildRequires:  python3-setuptools
BuildRequires:  python3-sqlalchemy
BuildRequires:  python3-testresources
BuildRequires:  python3-tomli-w
BuildRequires:  python3-pytest
BuildRequires:  python3-pytest-xdist
BuildRequires:  python3-pytest-xvfb
BuildRequires:  python3-wheel
BuildRequires:  xorg-x11-server-Xvfb

Requires:      python3-beautifulsoup4
Requires:      python3-keyring
Requires:      python3-setuptools
Requires:      python3-tomli_w
Requires:      hicolor-icon-theme

BuildArch:     noarch

%global _description %{expand:
A recipe manager for desktop with the possibilities to import, organize, and
tweak recipes.

Gourmand is a fork of the Gourmet Recipe Manager: a manager, editor, and
organizer for recipes.}

%description %_description


%prep
%autosetup -n %{srcname}-%{srcversion} -p 1


%build
%pyproject_wheel

%install
%pyproject_install
%pyproject_save_files %{name}
# Shebang fixes
%py3_shebang_fix %{buildroot}%{python3_sitelib}/gourmand/exporters/recipe_emailer.py
%py3_shebang_fix %{buildroot}%{python3_sitelib}/gourmand/gtk_extras/optionTable.py
%py3_shebang_fix %{buildroot}%{python3_sitelib}/gourmand/shopgui.py

%check
# Needs python3-ebooklib
# tests/test_reccard.py
%{py3_test_envvars}  LANGUAGE=de_DE.utf-8 xvfb-run -a pytest tests/test_prefs.py
%{py3_test_envvars}  LANGUAGE=de_DE.utf-8 xvfb-run -a pytest tests/test_pdf_exporter.py
%{py3_test_envvars}  LANGUAGE=de_DE.utf-8 xvfb-run -a pytest tests/test_pango_html.py
# Needs python3-scrape-schema-recipe
# tests/test_nutritional_information.py
%{py3_test_envvars}  LANGUAGE=de_DE.utf-8 xvfb-run -a pytest tests/test_interactive_importer.py
# Needs python3-scrape-schema-recipe
# tests/test_imports_from_files.py
%{py3_test_envvars}  LANGUAGE=de_DE.utf-8 xvfb-run -a pytest tests/test_importer.py
%{py3_test_envvars}  LANGUAGE=de_DE.utf-8 xvfb-run -a pytest tests/test_image_utils.py
# Needs python3-scrape-schema-recipe
# tests/test_exportManager.py
%{py3_test_envvars}  LANGUAGE=de_DE.utf-8 xvfb-run -a pytest tests/test_db.py
%{py3_test_envvars}  LANGUAGE=de_DE.utf-8 xvfb-run -a pytest tests/test_convert.py
%{py3_test_envvars}  LANGUAGE=de_DE.utf-8 xvfb-run -a pytest tests/test_clipboard_exporter.py

desktop-file-validate \
    %{buildroot}/%{_datadir}/applications/io.github.GourmandRecipeManager.Gourmand.desktop
appstream-util validate-relax --nonet \
     %{buildroot}%{_metainfodir}/io.github.GourmandRecipeManager.Gourmand.appdata.xml


%files -f %{pyproject_files}
%doc README.md
%{_bindir}/gourmand
%{_datadir}/applications/io.github.GourmandRecipeManager.Gourmand.desktop
%{_metainfodir}/io.github.GourmandRecipeManager.Gourmand.appdata.xml
%{_datadir}/icons/hicolor/*/apps/*.svg

%changelog
* Fri Oct 18 2024 Benson Muite <benson_muite@emailplus.org> - 1.1.0~rc3-1
- Initial packaging
